<div class="docs-primary-header component-page-header">
  <mat-chip-list>
    <mat-chip>
      <mat-icon>home</mat-icon>
      <a routerLink="/dashboard">Home</a>/
      <a routerLink="/products">Products</a>/Add Products

    </mat-chip>
  </mat-chip-list>
</div>

<div style="padding:15px;" class="appereance">
  <div class="title mat-elevation-z2">
    <span>ADD PRODUCT</span>
  </div>
  <mat-card>

    <form [formGroup]="usersGroup">
      <!-- <div class="row" [style.display]="(user == 'Admin')||(user == 'Distributer')||(user == 'Manufacturer') ? '' : 'none'"> -->
      <div class="row" [style.display]="usertype.user == 'Admin' ? '' : 'none'">

        <div class="col-md-12">
          <mat-card>
            <mat-radio-group formControlName="usertype" (change)="getRadio($event.value)">
              <mat-radio-button value="Manufacturer">Manufacturer</mat-radio-button>
              <mat-radio-button style="margin-left: 10px;" value="Distributor">Distributor</mat-radio-button>
              <mat-radio-button style="margin-left: 10px;" value="Admin">Admin</mat-radio-button>
            </mat-radio-group>
          </mat-card>
        </div>
      </div>
    </form>

    <mat-vertical-stepper [linear]="isLinear" #stepper>

      <mat-step [stepControl]="brandsGroup">

        <form [formGroup]="brandsGroup">
          <ng-template matStepLabel>Brand Details</ng-template>

          <div class="row">
            <div class="col-md-12">
              <!-- <mat-form-field [style.display]="(user == 'Admin')||(user == 'Distributer')||(user == 'Manufacturer') ? '' : 'none'"> -->

              <mat-form-field [style.display]="usertype.user == 'Admin' ? '' : 'none'">
                <mat-select placeholder="Name" formControlName="user_id">
                  <mat-option *ngFor="let user of users" [value]="user.id">
                    {{ user.name }}
                    <span *ngIf="user.unique_code!='null'">{{user.unique_code}}</span>
                  </mat-option>
                </mat-select>
                <mat-error *ngIf="brandsGroup.controls['user_id'].hasError('required')">
                  This field is
                  <strong>required</strong>
                </mat-error>
              </mat-form-field>
            </div>
          </div>

          <div class="row">
            <div class="col-md-12">
              <div formArrayName="addresses">
                <div *ngFor="let address of brandsGroup.controls.addresses.controls; let i=index;">
                  <div class="panel-body" [formGroupName]="i">
                    <span *ngIf="brandsGroup.controls.addresses.controls.length > 1" (click)="removeAddress(i)">
                      <a class="a-class">Remove</a>
                    </span>
                    <div class="row">
                      <div class="col-md-6">
                        <mat-form-field>
                          <mat-select placeholder="Brand" formControlName="brand_id" required>
                            <mat-option *ngFor="let brand of brands" [value]="brand.brand_id">
                              {{ brand.brand_name }}
                            </mat-option>
                          </mat-select>
                          <mat-error *ngIf="brandsGroup.controls.addresses.controls[i].controls.brand_id.hasError('required')">
                            This field is
                            <strong>required</strong>
                          </mat-error>
                        </mat-form-field>
                      </div>

                      <div class="col-md-6">
                        <mat-form-field class="form-field">
                          <input matInput placeholder="Brand Reference Number( use only alphanumeric )" formControlName="brand_reference"
                            required>
                          <mat-error *ngIf="brandsGroup.controls.addresses.controls[i].controls['brand_reference'].errors?.pattern">
                            Only numbers and alphabets are allowed
                          </mat-error>
                        </mat-form-field>

                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <a mat-icon-button (click)="addAddress()">
                <span style="font-family: 'Roboto Condensed', sans-serif;  color: grey; font-size: 16px;">Add Another
                  OE Reference +</span>
              </a>
            </div>
          </div>

          <div>
            <button mat-raised-button color="accent" style="margin-left: 5px;" matStepperNext>Next</button>
          </div>
        </form>
      </mat-step>
      <mat-step [stepControl]="productsGroup">
        <form [formGroup]="productsGroup">
          <ng-template matStepLabel>Product Details</ng-template>

          <div class="row">
            <div class="col-md-6">
              <mat-form-field>
                <mat-select placeholder="Category" formControlName="category_id" (selectionChange)="getSubCategory($event.value)"
                  required>
                  <mat-option *ngFor="let category of categories" [value]="category.category_id">
                    {{ category.category_name }}
                  </mat-option>
                </mat-select>
                <mat-error *ngIf="productsGroup.controls['category_id'].hasError('required')">
                  This field is
                  <strong>required</strong>
                </mat-error>
              </mat-form-field>
            </div>

            <div class="col-md-6">
              <mat-form-field>
                <mat-select placeholder="Sub-Category" formControlName="sub_category_id" (selectionChange)="getSubCategoryFields($event.value)"
                  required>
                  <mat-option *ngFor="let subcategory of subcategories" [value]="subcategory.sub_category_id">
                    {{ subcategory.sub_category_name }}
                  </mat-option>
                </mat-select>
                <mat-error *ngIf="productsGroup.controls['sub_category_id'].hasError('required')">
                  This field is
                  <strong>required</strong>
                </mat-error>
              </mat-form-field>
            </div>
          </div>

          <div class="row">
            <div class="col-md-4">
              <mat-form-field>
                <input matInput placeholder="Product Name" formControlName="product_name" required>
              </mat-form-field>
            </div>

            <div class="col-md-4">
              <mat-form-field>
                <mat-select placeholder="Product Type" formControlName="product_type" (selectionChange)="showProd($event.value)">
                  <mat-option value="Single">Single</mat-option>
                  <mat-option value="Configurable">Configurable</mat-option>
                </mat-select>
              </mat-form-field>
            </div>
            <div class="col-md-4">
              <mat-form-field>
                <input matInput placeholder="Part Number" formControlName="part_number" required>
                <mat-error *ngIf="productsGroup.controls['part_number'].errors?.pattern">
                  Only numbers and alphabets are allowed
                </mat-error>
              </mat-form-field>
            </div>
          </div>

          <div class="flex-container" [style.display]="showProducts == 'true' ? '':'none'">
            <mat-form-field>
              <input matInput (keyup)="search($event.target.value)" placeholder="Filter">
            </mat-form-field>

            <div *ngFor="let product of products;let i =index" class="col-md-2 colmd3">
              <!-- <mat-table #table [dataSource]="dataSource" matSort> -->
              <mat-card class="example-card">
                <mat-toolbar class="cardtitle">
                  <span><b>{{product.product_name}}</b></span>
                  <div style="flex-grow:1;"></div>
                </mat-toolbar>
                <mat-card-content>

                  <div class="overflow">
                    <p>
                      <b>Product Type:</b> {{product.product_type}}
                      <br>
                      <b style="color:brown">Quantity:</b> {{product.product_total_quantity}}
                      <br>
                      <b>Brand Name:</b> {{product.brand_details[0].brand_name}}
                      <br>
                      <b>Brand Ref No:</b> {{product.brand_details[0].brand_reference}}
                      <br>
                      <b>Distributor Ref No:</b> {{product.brand_details[0].distributor_reference}}
                      <br>
                      <b>OE Ref No:</b> {{product.brand_details[0].oe_reference}}
                      <br>
                      <b>{{product.usertype}} Name:</b> {{product.user_name}}
                      <br>
                      <b>Category Name:</b> {{product.category_name}}
                      <br>
                      <b>Sub-category Name:</b> {{product.sub_category_name}}
                      <br>

                      <!-- <br>
                      <b>Product Type:</b> {{product.product_type}}
                      <br> -->

                      <b>Cunsumer Price:</b> ₹ {{product.consumer_price}}
                      <br>
                      <b>Retailer Price:</b> ₹ {{product.retailer_price}}
                      <br>
                      <b>Distributor Price:</b> ₹ {{product.distributer_price}}
                      <br>

                      <ng-container *ngFor="let inputs of product.fields.inputFields">
                        <b>{{inputs.input}}:</b> {{inputs.value}}
                        <br>
                      </ng-container>
                      <ng-container *ngFor="let dropdowns of product.fields.dropdownFields">
                        <b>{{dropdowns.dropdown}}:</b> {{dropdowns.value}}
                        <br>
                      </ng-container>
                    </p>
                  </div>

                </mat-card-content>

                <mat-toolbar class="card-footer col-md-12">

                  <mat-form-field class="col-md-6">
                    <input matInput placeholder="Qty" #id [value]="this['all_quantity' + i] == undefined ? '':this['all_quantity' + i]">
                  </mat-form-field>
                  <mat-checkbox class="col-md-6" [checked]="product_ids.includes(product.product_id)" (change)="matcheck($event.checked,product.product_id,id.value,product.product_total_quantity)"
                    color="primary"></mat-checkbox>
                </mat-toolbar>

                <!-- <mat-card-content>
                        <mat-checkbox (change)="matcheck($event.checked,vehicle.vehicle_id)" color="primary"></mat-checkbox>
                      </mat-card-content> -->

              </mat-card>
              <!-- </mat-table> -->
            </div>


          </div>


          <div class="row">

            <mat-form-field>
              <textarea matInput class="input-circle" placeholder="description" formControlName="description" required></textarea>
            </mat-form-field>

            <!-- <div class="col-md-2">
                <mat-form-field>
                    <mat-select placeholder="gst" formControlName="gst">
                      <mat-option [value]="0">0%</mat-option>
                      <mat-option [value]="5">5%</mat-option>
                      <mat-option [value]="12">12%</mat-option>
                      <mat-option [value]="18">18%</mat-option>
                      <mat-option [value]="28">28%</mat-option>
                    </mat-select>
                  </mat-form-field>
            </div> -->

          </div>

          <div class="row">
            <div class="col-md-3">
              <button mat-raised-button color="accent" (click)="calculate()">Calculate</button>
            </div>

            <div class="col-md-3">
              <mat-form-field>
                <input matInput placeholder="Consumer Price" formControlName="consumer_price1" required>
              </mat-form-field>
            </div>

            <div class="col-md-3">
              <mat-form-field>
                <input matInput placeholder="Retailer Price" formControlName="retailer_price1" required>
              </mat-form-field>
            </div>

            <div class="col-md-3">
              <mat-form-field>
                <input matInput placeholder="Distributer Price" formControlName="distributer_price1" required>
              </mat-form-field>
            </div>


          </div>

          <div class="row">
            <div class="col-md-3">
              <mat-form-field>
                <input matInput placeholder="Quantity" formControlName="product_total_quantity" required>
              </mat-form-field>
            </div>

            <div class="col-md-3">
              <mat-form-field>
                <input matInput placeholder="Consumer Price" formControlName="consumer_price" required>
              </mat-form-field>
            </div>

            <div class="col-md-3">
              <mat-form-field>
                <input matInput placeholder="Retailer Price" formControlName="retailer_price" required>
              </mat-form-field>
            </div>

            <div class="col-md-3">
              <mat-form-field>
                <input matInput placeholder="Distributer Price" formControlName="distributer_price" required>
              </mat-form-field>
            </div>


          </div>

          <div class="row">
            <div class="col-md-3">
              <mat-form-field>
                <input matInput placeholder="Weight in(kg)" formControlName="weight" required>
                <mat-error *ngIf="productsGroup.controls.weight.errors?.required">weight is required</mat-error>
                <mat-error *ngIf="productsGroup.controls.weight.errors?.pattern">only numbers or numbers with decimal
                  are allowed</mat-error>

              </mat-form-field>
            </div>

            <div class="col-md-3">
              <mat-form-field>
                <input matInput placeholder="Height in(meters)" formControlName="height" required>
                <mat-error *ngIf="productsGroup.controls.height.errors?.required">Height is required</mat-error>
                <mat-error *ngIf="productsGroup.controls.height.errors?.pattern">only numbers or numbers with decimal
                  are allowed</mat-error>
              </mat-form-field>
            </div>

            <div class="col-md-3">
              <mat-form-field>
                <input matInput placeholder="Width in(meters)" formControlName="width" required>
                <mat-error *ngIf="productsGroup.controls.width.errors?.required">Width is required</mat-error>
                <mat-error *ngIf="productsGroup.controls.width.errors?.pattern">only numbers or numbers with decimal
                  are allowed</mat-error>
              </mat-form-field>
            </div>

            <div class="col-md-3">
              <mat-form-field>
                <input matInput placeholder="Length in(meters)" formControlName="length" required>
                <mat-error *ngIf="productsGroup.controls.length.errors?.required">Length is required</mat-error>
                <mat-error *ngIf="productsGroup.controls.length.errors?.pattern">only numbers or numbers with decimal
                  are allowed</mat-error>
              </mat-form-field>
            </div>


          </div>


          <div>
            <button mat-raised-button color="accent" matStepperPrevious>Back</button>
            <button mat-raised-button color="accent" style="margin-left: 5px;" matStepperNext>Next</button>
          </div>
        </form>
      </mat-step>
      <mat-step [stepControl]="fieldsGroup">
        <form [formGroup]="fieldsGroup">
          <ng-template matStepLabel>Additional Details</ng-template>

          <ng-container *ngFor="let fields of subcategoriesfields">
            <div class="row" *ngFor="let inputs of fields.fields.inputFields; let i = index">
              <div class="col-md-12">
                <mat-form-field>
                  <input matInput placeholder="{{inputs.input}}" formControlName="{{inputs.input.split(' ').join('')}}"
                    required>
                </mat-form-field>
              </div>
            </div>
          </ng-container>

          <ng-container *ngFor="let fields of subcategoriesfields">
            <div class="row" *ngFor="let dropdowns of fields.fields.dropdownFields">
              <div class="col-md-12">
                <mat-form-field>
                  <mat-select placeholder="{{dropdowns.dropdown}}" formControlName="{{dropdowns.dropdown.split(' ').join('')}}"
                    multiple>
                    <mat-option *ngFor="let dropdownList of dropdowns.dropdownList" [value]="dropdownList.option">
                      {{dropdownList.option}}
                    </mat-option>
                  </mat-select>
                </mat-form-field>
              </div>
            </div>
          </ng-container>

          <ng-container *ngIf="showPN == 'true'" style="margin-top: 15px;">
            <!-- (change)="uploadImage($event)" -->
            <!-- <image-upload [max]="5" [uploadedFiles]="showLogo" (uploadFinished)="uploadfile($event)" [fileTooLargeMessage]="'Please choose image size less than 2mb!'"  (removed)="onRemoved($event)"
               maxFileSize="2000000"
              ></image-upload> -->
              <image-upload  [uploadedFiles]="showLogo" (removed)="onRemoved($event)" (uploadFinished)="uploadfile($event)" [fileTooLargeMessage]="'Please choose image size less than 2mb!'" maxFileSize="2000000" ></image-upload>
          </ng-container>

          <div>
            <!-- <button type="reset" mat-raised-button color="accent">Reset</button> -->
            <button (click)="reset()" mat-raised-button color="accent">Reset</button>
            <button mat-raised-button color="accent" style="margin-left: 5px;" [disabled]="!fieldsGroup.valid || Hidden"
              (click)="onSubmit()">Submit</button>
          </div>
        </form>

      </mat-step>

    </mat-vertical-stepper>


  </mat-card>
</div>